/*
	smb explorer browser.js
*/

// extensions
var smbexplorer_ext_arr = ['txt', 'img'];
smbexplorer_ext_arr['txt'] = ['txt','inf'];
smbexplorer_ext_arr['img'] = ['jpg','png','gif','peg'];
  
var currpath = window.location.hash.replace( "#", "");

$(document).ready(function () {
    smbexplorer_onloadfn(); // I think this is good practice
});

function smbexplorer_onloadfn() {
	smbexplorer_loaddir(currpath);
}

// open specific path in file browser
function smbexplorer_loaddir(path) {
	$('#smbexplorer_browser').html('<img src="' + smbexplorer_webbase + 'images/loader_browser.gif" alt="loading"/>');
	if (path.length > 0) window.location.hash=path;
	$('#smbexplorer_browser').load( smbexplorer_q + smbexplorer_server_nr + '/ajax/getdir' , { path : path } , function(){
	  smbexplorer_loaddir_onload(path);
 	});
}

function smbexplorer_loaddir_onload(path){
  
  currpath = path;
  
  // open folder menu
  $(".smbexplorer_browser_dir").click(function (e) { 
		smbexplorer_browser_menu(e, path, $(this).attr('id'),'dir');
  });	
  
  // open file menu
  $(".smbexplorer_browser_file").click(function (e) { 
  	smbexplorer_browser_menu(e, path, $(this).attr('id'),'file');
  });	
  
  // folder up
  $(".smbexplorer_browser_up").click(function () { 
    var path_arr = path.split("/");
    smbexplorer_loaddir(path.substring(0,path.length - path_arr[path_arr.length - 1].length - 1));
  });

  // folder home
  $(".smbexplorer_browser_home").click(function () { 
    smbexplorer_loaddir("");
  });
  
  // reload folder
  $(".smbexplorer_browser_reload").click(function () { 
    var path_arr = path.split("/");
    smbexplorer_loaddir(path);
  });
  
  // paste file
  $(".smbexplorer_browser_paste").click(function () { 
    smbexplorer_paste(path);
  });
  
  // create dir
  $(".smbexplorer_browser_newdir").click(function () { 
    smbexplorer_newdir(path);
  });
  
  // upload file
  $(".smbexplorer_browser_upload").click(function () { 
    smbexplorer_upload(path);
  });
  
  // debug
  $(".smbexplorer_browser_debug").click(function () { 
    smbexplorer_debug();
  });
  
  
  // close upload box
  $("#smbexplorer_upload_options_close").unbind('click').bind('click', function () { 
    smbexplorer_upload_cancel();
  });
  
  // these buttons appear only if folder is not write forbidden
  if (!is_write_forbidden(path, smbexplorer_write_forbidden)) {
    // paste button appears only if there`s something in clipboard
    if (smbexplorer_clipboard[0] != false) {
      $(".smbexplorer_browser_paste").css('display','inline');
    }
    
    // create folder button
    $(".smbexplorer_browser_newdir").css('display','inline');
    
    // upload button
    $(".smbexplorer_browser_upload").css('display','inline');
  }
      
  // write forbidden check
  is_write_forbidden(path, smbexplorer_write_forbidden);
  
  // focus on user field if login form displayed
  if ($('input[@id="smbexplorer_user"]')[0] != undefined) $('input[@id="smbexplorer_user"]')[0].focus();
}

// preview/download file
function smbexplorer_getfile(path, download) {
	$('#smbexplorer_editor_title').html(smbexplorer_server_name + ' ' + path);
	
	var content = '';
	content += '<img onClick="$(\'#smbexplorer_editor\').slideUp(\'fast\'); smbexplorer_getfile(\'' + path + '\', true);" src="' + smbexplorer_webbase + 'images/save.png" alt="download" />';
	content += '<img onClick="$(\'#smbexplorer_editor\').slideUp();" src="' + smbexplorer_webbase + 'images/editor_close.png" alt="close"/>';
	$('.smbexplorer_editor_controls').html(content);	
	
	$('#smbexplorer_editor_file').html('<img src="' + smbexplorer_webbase + 'images/loader_browser.gif" alt="loading"/>');
	$('#smbexplorer_editor').slideDown();
	
	var path_arr = path.split(".");
  var ext = path_arr[path_arr.length - 1];

	if (download == true) {
		//document.location = smbexplorer_q + smbexplorer_server_nr + '/ajax/getfile/true' +  encodeURIComponent(path);
		document.location = smbexplorer_q + smbexplorer_server_nr + '/ajax/getfile/true' +  path;
		$('#smbexplorer_editor').slideUp();
	}	

  else if(smbexplorer_ext_arr['txt'].indexOf(ext.toLowerCase()) > -1) {
  	// save
  	$('#smbexplorer_editor_file').load(smbexplorer_q + smbexplorer_server_nr + '/ajax/getfile/false' , { path : path } , function(){
			$('#smbexplorer_editor_file').html('<textarea id="smbexplorer_editor_file_textarea" readonly="readonly">' + $('#smbexplorer_editor_file').html() + '</textarea>');
			$('#smbexplorer_editor').slideDown();
		});
	}
	else if(smbexplorer_ext_arr['img'].indexOf(ext.toLowerCase()) > -1) {
		$('#smbexplorer_editor_file').html('<img src="' + smbexplorer_q + smbexplorer_server_nr + '/ajax/getfile/false' + path + '" alt="file_preview" class="smbexplorer_editor_img"/>');
		$('#smbexplorer_editor').slideDown();
 	}
	else {
		document.location = smbexplorer_q + smbexplorer_server_nr + '/ajax/getfile/true' + path;
		$('#smbexplorer_editor').slideUp();
	}
}

// rename file/dir
function smbexplorer_rename(fname1) {
	var fname1_arr = fname1.split("/");
  	fname1 = fname1_arr[fname1_arr.length - 1];

	var fname2 = prompt(smbexplorer_t["rename_to"] + ":",fname1);
	
	if (fname2!=null && fname2!="") {
		smbexplorer_loading(true);
		$('#smbexplorer_editor_file').load(smbexplorer_q + smbexplorer_server_nr + '/ajax/rename' , { path : currpath , fname1 : fname1, fname2 : fname2 } , function(){
			//$('#smbexplorer_editor').slideDown();
			smbexplorer_loaddir(currpath);
			smbexplorer_loading(false);
		});
	}
}

// delete file/dir
function smbexplorer_delete(path) {
	var path_arr = path.split("/");
  	fname = path_arr[path_arr.length - 1];

	if (confirm(smbexplorer_t["really_delete"] + " "+fname+"?")) {
		smbexplorer_loading(true);
		$('#smbexplorer_editor_file').load(smbexplorer_q + smbexplorer_server_nr + '/ajax/delete' , { path : path } , function(){
			//$('#smbexplorer_editor').slideDown();
			smbexplorer_loaddir(currpath);
			smbexplorer_loading(false);
		});
	}
}

// cut file/dir
function smbexplorer_cut(path) {
	smbexplorer_clipboard = Array('cut', path);
}

// copy file/dir
function smbexplorer_copy(path) {
	smbexplorer_clipboard = Array('copy', path);
}

function smbexplorer_paste(path) {
  alert(smbexplorer_clipboard[0]);
  alert(smbexplorer_clipboard[1]);
  alert(path);
  
  smbexplorer_loading(true);
  $('#smbexplorer_editor_file').load(smbexplorer_q + smbexplorer_server_nr + '/ajax/paste' , { action: smbexplorer_clipboard[0], path_from : smbexplorer_clipboard[1], path_to : path } , function(){
    if (smbexplorer_clipboard[0] == 'cut') alert('File moved');
    else alert('File copied');
    smbexplorer_loaddir(currpath);
    smbexplorer_loading(false);
	});
}

function smbexplorer_upload(path){
	content = '<form enctype="multipart/form-data" method="POST" target="smbexplorer_uploadframe"><input type="file" id="smbexplorer_fileupload" name="Filedata" / onChange="javascript:smbexplorer_noswfu_submitfile(this)"><input type="hidden" name="path" value="' + currpath + '"></form>';
	$('#smbexplorer_upload_content').html(content);
	
  $('#smbexplorer_uploadbox').css('top', ($(window).height()/2-$("#smbexplorer_uploadbox").height()/2) +  "px");
  $('#smbexplorer_uploadbox').css('left', ($(window).width()/2-$("#smbexplorer_uploadbox").width()/2) + "px");
 	$('#smbexplorer_uploadbox').fadeIn();
}

function smbexplorer_upload_cancel(path){
	$('#smbexplorer_upload_content').html(smbexplorer_t["cancelled"] + '!');
	$('#smbexplorer_uploadbox').fadeOut();
}


/* 
	noswfu file upload routine 
	taken from prog gallery (my :P) module
*/
function smbexplorer_noswfu_submitfile(elem) {
	
	content = '<img src="' + smbexplorer_webbase + 'images/loader_browser.gif" alt="loading"/>';
	
	// create iframe for upload
	content += '<iframe id="smbexplorer_uploadframe" name="smbexplorer_uploadframe" class="smbexplorer_noswfu_iframe" scrolling="no" marginwidth="0" marginheight="0" width="1" height="1"></iframe>';
	$('#smbexplorer_upload_content').prepend(content);
	
	// on iframe load, do stuff
	$('#smbexplorer_uploadframe').load(function(){
		
		// get status
		status = $('#smbexplorer_uploadframe').contents().children(":first").text();
		if (status != '') {
			eval("var status_obj="+status);
		
		  if (status_obj.status == 'ok') {
		  	//$('#smbexplorer_upload_content').html('<span class="smbexplorer_upload_ok">ok</span><br /><span class="smbexplorer_upload_bad_size">' + status_obj.size + '</span>');
		  	smbexplorer_loaddir(currpath);    
		  	$('#smbexplorer_uploadbox').fadeOut('slow');
		  } 
		  else $('#smbexplorer_upload_content').html('<span class="smbexplorer_upload_bad">' + status_obj.status + '</span>');
		}
	});		
	
	// submit file 
	$('#smbexplorer_fileupload').parent().attr('action', smbexplorer_q  +  smbexplorer_server_nr + '/ajax/upload');
	//$('#smbexplorer_fileupload').parent().attr('enctype', 'multipart/form-data');
	//$('#smbexplorer_fileupload').parent().attr('method', 'post');
	//$('#smbexplorer_fileupload').parent().attr('target', 'smbexplorer_uploadframe');
	$('#smbexplorer_fileupload').parent().submit();
	
	// hide this upload form
	$(elem).hide();
}


function smbexplorer_newdir(path) {
	var newdir = prompt(smbexplorer_t["create_folder"] + ":");
	
	if (newdir!=null && newdir!="") {
		smbexplorer_loading(true);
		$('#smbexplorer_editor_file').load(smbexplorer_q + smbexplorer_server_nr + '/ajax/newdir' , { path : currpath , newdir : newdir } , function(){
			smbexplorer_loaddir(currpath);
			smbexplorer_loading(false);
		});
	}
}


/*
	popup menu (appears when clicked on file)
*/
function smbexplorer_browser_menu(e, path, file, type){
	var menucontent = '';
	
	// open directory
	if (type == 'dir') {
		menucontent += '<div onClick="$(this).parent().fadeOut(\'fast\'); smbexplorer_loaddir(\'' + path + '/' + file + '\');"><img src="' + smbexplorer_webbase + 'images/dir_open16.png" alt="+" class="smbexplorer_browser_imgtip" /> ' + smbexplorer_t["open"] + '</div>';
	}
	// open directory
	if (type == 'file') {
		var path_arr = file.split(".");
  	var ext = path_arr[path_arr.length - 1];

		// if we can, offer preview
		if((smbexplorer_ext_arr['txt'].indexOf(ext.toLowerCase()) > -1) || (smbexplorer_ext_arr['img'].indexOf(ext.toLowerCase()) > -1)) {
			menucontent += '<div  onClick="$(this).parent().fadeOut(\'fast\'); smbexplorer_getfile(\'' + path + '/' + file + '\', false);" ><img src="' + smbexplorer_webbase + 'images/preview16.png" alt="+" class="smbexplorer_browser_imgtip" /> ' + smbexplorer_t["preview"] + '</div>';
		} 
		
		// save (download)
		menucontent += '<div onClick="$(this).parent().fadeOut(\'fast\'); smbexplorer_getfile(\'' + path + '/' + file + '\', true);"><img src="' + smbexplorer_webbase + 'images/save16.png" alt="+" class="smbexplorer_browser_imgtip" /> ' + smbexplorer_t["download"] + '</div>';
		
	}

	// write actions
	if (!is_write_forbidden(path + '/' + file, smbexplorer_write_forbidden)) {
	  // rename
		menucontent += '<div onClick="$(this).parent().fadeOut(\'fast\'); smbexplorer_rename(\'' + path + '/' + file + '\');"><img src="' + smbexplorer_webbase + 'images/rename.png" alt="+" class="smbexplorer_browser_imgtip" /> ' + smbexplorer_t["rename"] + '</div>';
	
	  // delete
		menucontent += '<div onClick="$(this).parent().fadeOut(\'fast\'); smbexplorer_delete(\'' + path + '/' + file + '\');"><img src="' + smbexplorer_webbase + 'images/delete16.png" alt="+" class="smbexplorer_browser_imgtip" /> ' + smbexplorer_t["delete"] + '</div>';
	
	  /*
	  // cut
		menucontent += '<div onClick="$(this).parent().fadeOut(\'fast\'); smbexplorer_cut(\'' + path + '/' + file + '\');"><img src="' + smbexplorer_webbase + 'images/cut.png" alt="+" class="smbexplorer_browser_imgtip" /> Cut</div>';
		*/
	}
	/*
	// copy
	menucontent += '<div onClick="$(this).parent().fadeOut(\'fast\'); smbexplorer_copy(\'' + path + '/' + file + '\');"><img src="' + smbexplorer_webbase + 'images/copy.png" alt="+" class="smbexplorer_browser_imgtip" /> Copy</div>';
  
   if (!is_write_forbidden(path + '/' + file, smbexplorer_write_forbidden)) {
    if (type == 'dir') {
      if (smbexplorer_clipboard[0] != false) {
        // paste if path is not forbidden
	      menucontent += '<div onClick="$(this).parent().fadeOut(\'fast\'); smbexplorer_paste(\'' + path + '/' + file + '\');"><img src="' + smbexplorer_webbase + 'images/paste16.png" alt="+" class="smbexplorer_browser_imgtip" /> Paste</div>';
      }
	  }
	 }
  */
  
	// close button
	menucontent += '<div onClick="$(this).parent().fadeOut(\'fast\')"><img src="' + smbexplorer_webbase + 'images/editor_close16.png" alt="+" class="smbexplorer_browser_imgtip" /> ' + smbexplorer_t["cancel"] + '</div>';
	
	$(".smbexplorer_browser_menu").html(menucontent);
	$(".smbexplorer_browser_menu").css('top',(e.pageY - 20) + "px").css('left',(e.pageX - 20) + "px").fadeIn('fast');
}

function smbexplorer_login(path) {
  var post_arr = new Array();
  
  post_arr[0] = new Array();
  post_arr[0]['name'] = "path";
  post_arr[0]['value'] = path;
  
  post_arr[1] = new Array();
  post_arr[1]['name'] = "user";
  post_arr[1]['value'] = $("#smbexplorer_user").attr('value');
  
  post_arr[2] = new Array();
  post_arr[2]['name'] = "pass";
  post_arr[2]['value'] = $("#smbexplorer_pass").attr('value'); 
  
  $('#smbexplorer_browser').html('<img src="' + smbexplorer_webbase + 'images/loader_browser.gif" alt="loading"/>');
	
  $('#smbexplorer_browser').load(smbexplorer_q + smbexplorer_server_nr + '/ajax/login' , post_arr , function(){
    smbexplorer_loaddir_onload(path);
  }); 
}

function smbexplorer_loading(show) {
	if (show == true) {
		$('#smbexplorer_loading').css('top', ($(window).height()/2-$("#smbexplorer_loading").height()/2) +  "px");
  	$('#smbexplorer_loading').css('left', ($(window).width()/2-$("#smbexplorer_loading").width()/2) + "px");
 	
		$('#smbexplorer_loading').fadeIn();
	} 
	else {
		$('#smbexplorer_loading').fadeOut();
	}
}

function smbexplorer_debug() {
  $('.smbexplorer_debuginfo').toggle(); 
}

// simulate #op button click when return button pushed
function chkkey(id,event) {
  if (event.keyCode == 13) $('#op').click();
}

function is_write_forbidden(path, forbidden_path) {
  if (forbidden_path.length == 0) return false;
  if (path.substring(0,forbidden_path.length) == forbidden_path) return true;
  else return false;
}


/* 
	array.indexOf prototype for Javascript 1.5 (IE6 etc.)
	Author: Stella Power
	http://www.stellapower.net/blog/javascript-support-and-arrayindexof-ie
*/
if(!Array.prototype.indexOf){
    Array.prototype.indexOf=function(obj,start){
        for(var i=(start||0),j=this.length;i<j;i++){
            if(this[i]==obj){return i;}
        }
        return -1;
    }
}
